/*!
 * Application Insights JavaScript SDK - Properties Plugin, 3.3.8
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
"use strict";var strShimFunction="function",strShimObject="object",strShimUndefined="undefined",strShimPrototype="prototype",ObjClass$1=Object;function _pureAssign(e,t){return e||t}function _pureRef(e,t){return e[t]}var _primitiveTypes,UNDEF_VALUE=undefined,NULL_VALUE=null,EMPTY="",FUNCTION="function",OBJECT="object",PROTOTYPE="prototype",__PROTO__="__proto__",UNDEFINED="undefined",CONSTRUCTOR="constructor",SYMBOL="Symbol",LENGTH="length",NAME="name",CALL="call",TO_STRING="toString",GET_OWN_PROPERTY_DESCRIPTOR="getOwnPropertyDescriptor",ObjClass=_pureAssign(Object),ObjProto=_pureRef(ObjClass,PROTOTYPE),StrCls=_pureAssign(String),StrProto=_pureRef(StrCls,PROTOTYPE),MathCls=_pureAssign(Math),ArrCls=_pureAssign(Array),ArrProto=_pureRef(ArrCls,PROTOTYPE),ArrSlice=_pureRef(ArrProto,"slice"),POLYFILL_TAG="_polyfill",POLYFILL_TYPE_NAME="__nw21$polytype__";function safe(e,t){try{return{v:e.apply(this,t)}}catch(n){return{e:n}}}function _createIs(t){return function(e){return typeof e===t}}function _createObjIs(e){var t="[object "+e+"]";return function(e){return!(!e||objToString(e)!==t)}}function objToString(e){return ObjProto[TO_STRING].call(e)}function isUndefined(e){return typeof e===UNDEFINED||e===UNDEFINED}function isStrictUndefined(e){return e===UNDEF_VALUE}function isNullOrUndefined(e){return e===NULL_VALUE||isUndefined(e)}function isStrictNullOrUndefined(e){return e===NULL_VALUE||e===UNDEF_VALUE}function isDefined(e){return!!e||e!==UNDEF_VALUE}function isPrimitiveType(e){return _primitiveTypes=_primitiveTypes||["string","number","boolean",UNDEFINED,"symbol","bigint"],!(e===OBJECT||!~_primitiveTypes.indexOf(e))}var isString=_createIs("string"),isFunction=_createIs(FUNCTION);function isObject(e){return!(!e&&isNullOrUndefined(e)||!e||typeof e!==OBJECT)}var isArray=_pureRef(ArrCls,"isArray"),isDate=_createObjIs("Date");function isPromiseLike(e){return!!(e&&e.then&&isFunction(e.then))}function _returnNothing(){}function _returnFalse(){return!1}var asString=_pureAssign(StrCls),ERROR_TYPE="[object Error]";function dumpObj(e,t){var n=EMPTY,r=ObjProto[TO_STRING][CALL](e);r===ERROR_TYPE&&(e={stack:asString(e.stack),message:asString(e.message),name:asString(e.name)});try{n=((n=JSON.stringify(e,NULL_VALUE,t?"number"==typeof t?t:4:UNDEF_VALUE))?n.replace(/"(\w+)"\s*:\s{0,1}/g,"$1: "):NULL_VALUE)||asString(e)}catch(o){n=" - "+dumpObj(o,t)}return r+": "+n}function throwTypeError(e){throw new TypeError(e)}function _throwIfNullOrUndefined(e){isStrictNullOrUndefined(e)&&throwTypeError("Cannot convert undefined or null to object")}function objHasOwnProperty(e,t){return!!e&&ObjProto.hasOwnProperty[CALL](e,t)}var _objGetOwnPropertyDescriptor$2=_pureAssign(_pureRef(ObjClass,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),objHasOwn=_pureAssign(_pureRef(ObjClass,"hasOwn"),polyObjHasOwn);function polyObjHasOwn(e,t){return _throwIfNullOrUndefined(e),objHasOwnProperty(e,t)||!!_objGetOwnPropertyDescriptor$2(e,t)}function objForEachKey(e,t,n){if(e&&(isObject(e)||isFunction(e)))for(var r in e)if(objHasOwn(e,r)&&-1===t[CALL](n||e,r,e[r]))break}function arrForEach(e,t,n){if(e)for(var r=e[LENGTH]>>>0,o=0;o<r&&!(o in e&&-1===t[CALL](n||e,e[o],o,e));o++);}var _unwrapFunction=_unwrapFunctionWithPoly;function _unwrapFunctionWithPoly(r,e,o){var a=e?e[r]:NULL_VALUE;return function(e){var t,n=(e?e[r]:NULL_VALUE)||a;if(n||o)return t=arguments,(n||o).apply(e,n?ArrSlice[CALL](t,1):t);throwTypeError('"'+asString(r)+'" not defined for '+dumpObj(e))}}var _objGetOwnPropertyDescriptor$1=_pureAssign(_pureRef(ObjClass,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),propMap={e:"enumerable",c:"configurable",v:"value",w:"writable",g:"get",s:"set"};function _createProp(t){var e,n={};return n[propMap.c]=!0,n[propMap.e]=!0,t.l&&(n.get=function(){return t.l.v},(e=_objGetOwnPropertyDescriptor$1(t.l,"v"))&&e.set&&(n.set=function(e){t.l.v=e})),objForEachKey(t,function(e,t){n[propMap[e]]=isStrictUndefined(t)?n[propMap[e]]:t}),n}var objDefineProp=_pureRef(ObjClass,"defineProperty"),objDefineProperties=_pureRef(ObjClass,"defineProperties");function objDefine(e,t,n){return objDefineProp(e,t,_createProp(n))}function _createKeyValueMap(e,n,r,t,o){var a={};return objForEachKey(e,function(e,t){_assignMapValue(a,e,n?t:e),_assignMapValue(a,t,r?t:e)}),t?t(a):a}function _assignMapValue(e,t,n,r){objDefineProp(e,t,{value:n,enumerable:!0,writable:!1})}var objIsFrozen=_pureAssign(_pureRef(ObjClass,"isFrozen"),_returnFalse),_objFreeze=_pureRef(ObjClass,"freeze");function _doNothing(e){return e}function _getProto(e){return _throwIfNullOrUndefined(e),e[__PROTO__]||NULL_VALUE}var objKeys=_pureRef(ObjClass,"keys");function _deepFreeze(e,n){if((isArray(e)||isObject(e)||isFunction(e))&&!objIsFrozen(e)){for(var t=0;t<n.length;t++)if(n[t]===e)return e;n.push(e),objForEachKey(e,function(e,t){_deepFreeze(t,n)}),objFreeze(e)}return e}function objDeepFreeze(e){return _objFreeze?_deepFreeze(e,[]):e}var objFreeze=_pureAssign(_objFreeze,_doNothing),objGetPrototypeOf=_pureAssign(_pureRef(ObjClass,"getPrototypeOf"),_getProto);function createEnumKeyMap(e){return _createKeyValueMap(e,0,0,objFreeze)}var _globalCfg,_wellKnownSymbolMap=createEnumKeyMap({asyncIterator:0,hasInstance:1,isConcatSpreadable:2,iterator:3,match:4,matchAll:5,replace:6,search:7,species:8,split:9,toPrimitive:10,toStringTag:11,unscopables:12}),GLOBAL_CONFIG_KEY="__tsUtils$gblCfg";function _getGlobalValue(){var e;return(e=(e=(e=typeof globalThis!==UNDEFINED?globalThis:e)||typeof self===UNDEFINED?e:self)||typeof window===UNDEFINED?e:window)||typeof global===UNDEFINED?e:global}function _getGlobalConfig(){var e;return _globalCfg||(e=safe(_getGlobalValue).v||{},_globalCfg=e[GLOBAL_CONFIG_KEY]=e[GLOBAL_CONFIG_KEY]||{}),_globalCfg}function _tagAsPolyfill(e,t){return e&&(safe(function(){e[POLYFILL_TAG]=!0,e[POLYFILL_TYPE_NAME]=t}),safe(objDefine,[e,POLYFILL_TAG,{v:!0,w:!1,e:!1}]),safe(objDefine,[e,POLYFILL_TYPE_NAME,{v:t,w:!1,e:!1}])),e}var _globalLazyTestHooks,objCreate=_pureAssign(_pureRef(ObjClass,"create"),polyObjCreate);function polyObjCreate(e,t){var n;function r(){}return n=isStrictNullOrUndefined(e)?{}:((n=typeof e)!==OBJECT&&n!==FUNCTION&&throwTypeError("Prototype must be an Object or function: "+dumpObj(e)),r[PROTOTYPE]=e,safe(function(){r[__PROTO__]=e}),new r),t&&safe(objDefineProperties,[n,t]),n}function utcNow(){return(Date.now||polyUtcNow)()}function polyUtcNow(){return(new Date).getTime()}function fnApply(e,t,n){return e.apply(t,n)}function _initTestHooks(){_globalLazyTestHooks=_getGlobalConfig()}function getLazy(t,n){var r={};return _globalLazyTestHooks||_initTestHooks(),r.b=_globalLazyTestHooks.lzy,objDefineProp(r,"v",{configurable:!0,get:function(){var e=fnApply(t,null,n);return _globalLazyTestHooks.lzy||objDefineProp(r,"v",{value:e}),r.b=_globalLazyTestHooks.lzy,e}}),r}var _polySymbols,_wellKnownSymbolCache,mathRandom=_pureRef(MathCls,"random"),_uniqueInstanceId=getLazy(function(){for(var e=utcNow().toString(36).slice(2);e.length<16;)e+=mathRandom().toString(36).slice(2);return e.substring(0,16)}),UNIQUE_REGISTRY_ID="_urid",POLY_SYM="$nw21sym",_polyId=0;function _globalSymbolRegistry(){var e;return _polySymbols||(e=_getGlobalConfig(),_polySymbols=e.gblSym=e.gblSym||{k:{},s:{}}),_polySymbols}function polyNewSymbol(e){var t="_"+_polyId+++"_"+_uniqueInstanceId.v,n=SYMBOL+"("+e+")";function r(e,t){objDefine(o,e,{v:t,e:!1,w:!1})}var o=objCreate(null);return r("description",asString(e)),r(TO_STRING,function(){return n+POLY_SYM+t}),r("valueOf",function(){return o}),r("v",n),r("_uid",t),_tagAsPolyfill(o,"symbol")}function polySymbolFor(e){var t,n,r=_globalSymbolRegistry();return objHasOwn(r.k,e)||(t=polyNewSymbol(e),n=objKeys(r.s).length,t[UNIQUE_REGISTRY_ID]=function(){return n+"_"+t[TO_STRING]()},r.k[e]=t,r.s[t[UNIQUE_REGISTRY_ID]()]=asString(e)),r.k[e]}function polyGetKnownSymbol(e){_wellKnownSymbolCache=_wellKnownSymbolCache||{};e=_wellKnownSymbolMap[e];return e?_wellKnownSymbolCache[e]=_wellKnownSymbolCache[e]||polyNewSymbol(SYMBOL+"."+e):void 0}function createCachedValue(e){return objDefineProp({toJSON:function(){return e}},"v",{value:e})}var _cachedGlobal,WINDOW="window";function _getGlobalInstFn(e,t){var n;return function(){return _globalLazyTestHooks||_initTestHooks(),(n=n&&!_globalLazyTestHooks.lzy?n:createCachedValue(safe(e,t).v)).v}}function getGlobal(e){return _globalLazyTestHooks||_initTestHooks(),(_cachedGlobal=_cachedGlobal&&!1!==e&&!_globalLazyTestHooks.lzy?_cachedGlobal:createCachedValue(safe(_getGlobalValue).v||NULL_VALUE)).v}function getInst(e,t){t=_cachedGlobal&&!1!==t?_cachedGlobal.v:getGlobal(t);if(t&&t[e])return t[e];if(e===WINDOW)try{return window}catch(n){}return NULL_VALUE}var getDocument=_getGlobalInstFn(getInst,["document"]);function hasWindow(){return!!getWindow()}var _symbol,_symbolFor,_iterSymbol$1,getWindow=_getGlobalInstFn(getInst,[WINDOW]),getNavigator=_getGlobalInstFn(getInst,["navigator"]);function _initSymbol(){return _symbol=createCachedValue(safe(getInst,[SYMBOL]).v)}function _getSymbolKey(e){var t=(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol();return t.v?t.v[e]:UNDEF_VALUE}function getKnownSymbol(e,t){var n=_wellKnownSymbolMap[e],r=(_globalLazyTestHooks||_initTestHooks(),(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol());return r.v?r.v[n||e]:t?UNDEF_VALUE:polyGetKnownSymbol(e)}function newSymbol(e,t){_globalLazyTestHooks||_initTestHooks();var n=(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol();return n.v?n.v(e):t?NULL_VALUE:polyNewSymbol(e)}function symbolFor(e){return _globalLazyTestHooks||_initTestHooks(),((_symbolFor=(_globalLazyTestHooks.lzy?0:_symbolFor)||createCachedValue(safe(_getSymbolKey,["for"]).v)).v||polySymbolFor)(e)}function isIterator(e){return!!e&&isFunction(e.next)}function isIterable(e){return!isStrictNullOrUndefined(e)&&isFunction(e[getKnownSymbol(3)])}function iterForOf(e,t,n){if(e&&(isIterator(e)||(e=e[(_iterSymbol$1=_iterSymbol$1||createCachedValue(getKnownSymbol(3))).v]?e[_iterSymbol$1.v]():NULL_VALUE),isIterator(e))){var r=UNDEF_VALUE,o=UNDEF_VALUE;try{for(var a=0;!(o=e.next()).done&&-1!==t[CALL](n||e,o.value,a,e);)a++}catch(i){r={e:i},e["throw"]&&(o=NULL_VALUE,e["throw"](r))}finally{try{o&&!o.done&&e["return"]&&e["return"](o)}finally{if(r)throw r.e}}}}function arrAppend(t,e){return!isUndefined(e)&&t&&(isArray(e)?fnApply(t.push,t,e):isIterator(e)||isIterable(e)?iterForOf(e,function(e){t.push(e)}):t.push(e)),t}var _isProtoArray,arrIndexOf=_unwrapFunctionWithPoly("indexOf",ArrProto),objSetPrototypeOf=_pureAssign(_pureRef(ObjClass,"setPrototypeOf"),_polyObjSetPrototypeOf);function _polyObjSetPrototypeOf(n,e){var t;return(_isProtoArray=_isProtoArray||createCachedValue(((t={})[__PROTO__]=[],t instanceof Array))).v?n[__PROTO__]=e:objForEachKey(e,function(e,t){return n[e]=t}),n}function _createCustomError(e,t,n){function r(){this[CONSTRUCTOR]=t,safe(objDefine,[this,NAME,{v:e,c:!0,e:!1}])}return safe(objDefine,[t,NAME,{v:e,c:!0,e:!1}]),(t=objSetPrototypeOf(t,n))[PROTOTYPE]=n===NULL_VALUE?objCreate(n):(r[PROTOTYPE]=n[PROTOTYPE],new r),t}function _setName(e,t){t&&(e[NAME]=t)}function createCustomError(o,a,e){var i=e||Error,_=i[PROTOTYPE][NAME],u=Error.captureStackTrace;return _createCustomError(o,function(){var e=this,t=arguments;try{safe(_setName,[i,o]);var n,r=fnApply(i,e,ArrSlice[CALL](t))||e;return r!==e&&(n=objGetPrototypeOf(e))!==objGetPrototypeOf(r)&&objSetPrototypeOf(r,n),u&&u(r,e[CONSTRUCTOR]),a&&a(r,t),r}finally{safe(_setName,[i,_])}},i)}var _fnToString,_objCtrFnString,_gblWindow,mathFloor=_pureRef(MathCls,"floor");function isPlainObject(e){if(!e||typeof e!==OBJECT)return!1;var t=!1;if(e!==(_gblWindow=_gblWindow||!hasWindow()||getWindow())){_objCtrFnString||(_fnToString=Function[PROTOTYPE][TO_STRING],_objCtrFnString=_fnToString[CALL](ObjClass));try{var n=objGetPrototypeOf(e),t=(t=!n)||!(!(n=objHasOwnProperty(n,CONSTRUCTOR)?n[CONSTRUCTOR]:n)||typeof n!==FUNCTION||_fnToString[CALL](n)!==_objCtrFnString)}catch(r){}}return t}function _defaultDeepCopyHandler(e){return e.value&&plainObjDeepCopyHandler(e),!0}var defaultDeepCopyHandlers=[arrayDeepCopyHandler,plainObjDeepCopyHandler,functionDeepCopyHandler,dateDeepCopyHandler];function _getSetVisited(e,t,n,r){var o;return arrForEach(e,function(e){if(e.k===t)return o=e,-1}),o||(o={k:t,v:t},e.push(o),r(o)),o.v}function _deepCopy(n,e,r,t){var o=r.handler,t=r.path?t?r.path.concat(t):r.path:[],a={handler:r.handler,src:r.src,path:t},i=typeof e,_=!1,u=e===NULL_VALUE,c=(u||(e&&i===OBJECT?_=isPlainObject(e):u=isPrimitiveType(i)),{type:i,isPrim:u,isPlain:_,value:e,result:e,path:t,origin:r.src,copy:function(e,t){return _deepCopy(n,e,t?a:r,t)},copyTo:function(e,t){return _copyProps(n,e,t,a)}});return c.isPrim?o&&o[CALL](r,c)?c.result:e:_getSetVisited(n,e,t,function(t){objDefine(c,"result",{g:function(){return t.v},s:function(e){t.v=e}});for(var e=0,n=o;!(n||(e<defaultDeepCopyHandlers.length?defaultDeepCopyHandlers[e++]:_defaultDeepCopyHandler))[CALL](r,c);)n=NULL_VALUE})}function _copyProps(e,t,n,r){if(!isNullOrUndefined(n))for(var o in n)t[o]=_deepCopy(e,n[o],r,o);return t}function objCopyProps(e,t,n){return _copyProps([],e,t,{handler:n,src:t,path:[]})}function arrayDeepCopyHandler(e){var t,n=e.value;return!!isArray(n)&&((t=e.result=[]).length=n.length,e.copyTo(t,n),!0)}function dateDeepCopyHandler(e){var t=e.value;return!!isDate(t)&&(e.result=new Date(t.getTime()),!0)}function functionDeepCopyHandler(e){return e.type===FUNCTION}function plainObjDeepCopyHandler(e){var t,n=e.value;return!(!n||!e.isPlain||(t=e.result={},e.copyTo(t,n),0))}function _doExtend(t,e){return arrForEach(e,function(e){objCopyProps(t,e)}),t}function objExtend(e,t,n,r,o,a,i){return _doExtend(e||{},ArrSlice[CALL](arguments))}var strSplit=_unwrapFunctionWithPoly("split",StrProto);function setValueByKey(t,e,n){var r;t&&e&&(r=(e=strSplit(e,".")).pop(),arrForEach(e,function(e){isNullOrUndefined(t[e])&&(t[e]={}),t=t[e]}),t[r]=n)}var _setTimeoutFn,_clearTimeoutFn,objGetOwnPropertyDescriptor=_pureAssign(_pureRef(ObjClass,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),strIndexOf=_unwrapFunctionWithPoly("indexOf",StrProto),REF="ref",UNREF="unref",HAS_REF="hasRef",ENABLED="enabled";function _createTimerHandler(e,t,n){var r,o=!0,a=e?t(NULL_VALUE):NULL_VALUE;function i(){return o=!1,a&&a[UNREF]&&a[UNREF](),r}function _(){a&&n(a),a=NULL_VALUE}function u(){return a=t(a),o||i(),r}return(r={cancel:_,refresh:u})[HAS_REF]=function(){return a&&a[HAS_REF]?a[HAS_REF]():o},r[REF]=function(){return o=!0,a&&a[REF]&&a[REF](),r},r[UNREF]=i,{h:r=objDefineProp(r,ENABLED,{get:function(){return!!a},set:function(e){!e&&a&&_(),e&&!a&&u()}}),dn:function(){a=NULL_VALUE}}}function _resolveTimeoutFn(e){var t,e=isFunction(e)?e:_setTimeoutFn;return e||(t=_getGlobalConfig().tmOut||[],isArray(t)&&0<t.length&&isFunction(t[0])&&(e=t[0])),e||setTimeout}function _resolveClearTimeoutFn(e){var t,e=isFunction(e)?e:_clearTimeoutFn;return e||(t=_getGlobalConfig().tmOut||[],isArray(t)&&1<t.length&&isFunction(t[1])&&(e=t[1])),e||clearTimeout}function _createTimeoutWith(e,t,n){var r=isArray(t),o=r?t.length:0,a=_resolveTimeoutFn(0<o?t[0]:r?UNDEF_VALUE:t),i=_resolveClearTimeoutFn(1<o?t[1]:UNDEF_VALUE),_=n[0],u=(n[0]=function(){u.dn(),fnApply(_,UNDEF_VALUE,ArrSlice[CALL](arguments))},_createTimerHandler(e,function(e){if(e){if(e.refresh)return e.refresh(),e;fnApply(i,UNDEF_VALUE,[e])}return fnApply(a,UNDEF_VALUE,n)},function(e){fnApply(i,UNDEF_VALUE,[e])}));return u.h}function scheduleTimeout(e,t){return _createTimeoutWith(!0,UNDEF_VALUE,ArrSlice[CALL](arguments))}(getGlobal()||{}).Symbol,(getGlobal()||{}).Reflect;var _a$3,strHasOwnProperty="hasOwnProperty",extendStaticsFn=function(e,t){return(extendStaticsFn=ObjClass$1.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t[strHasOwnProperty](n)&&(e[n]=t[n])})(e,t)};function __extendsFn(e,t){function n(){this.constructor=e}typeof t!==strShimFunction&&null!==t&&throwTypeError("Class extends value "+t+" is not a constructor or null"),extendStaticsFn(e,t),e[strShimPrototype]=null===t?objCreate(t):(n[strShimPrototype]=t[strShimPrototype],new n)}var Constructor="constructor",Prototype="prototype",strFunction="function",DynInstFuncTable="_dynInstFuncs",DynProxyTag="_isDynProxy",DynClassName="_dynClass",DynClassNamePrefix="_dynCls$",DynInstChkTag="_dynInstChk",DynAllowInstChkTag=DynInstChkTag,DynProtoDefaultOptions="_dfOpts",UnknownValue="_unknown_",str__Proto="__proto__",DynProtoBaseProto="_dyn"+str__Proto,DynProtoGlobalSettings="__dynProto$Gbl",DynProtoCurrent="_dynInstProto",strUseBaseInst="useBaseInst",strSetInstFuncs="setInstFuncs",Obj=Object,_objGetPrototypeOf=Obj.getPrototypeOf,_objGetOwnProps=Obj.getOwnPropertyNames,_gbl=getGlobal(),_gblInst=_gbl[DynProtoGlobalSettings]||(_gbl[DynProtoGlobalSettings]={o:((_a$3={})[strSetInstFuncs]=!0,_a$3[strUseBaseInst]=!0,_a$3),n:1e3});function _isObjectOrArrayPrototype(e){return e&&(e===Obj[Prototype]||e===Array[Prototype])}function _isObjectArrayOrFunctionPrototype(e){return _isObjectOrArrayPrototype(e)||e===Function[Prototype]}function _getObjProto(e){if(e){if(_objGetPrototypeOf)return _objGetPrototypeOf(e);var t=e[str__Proto]||e[Prototype]||(e[Constructor]?e[Constructor][Prototype]:null),n=e[DynProtoBaseProto]||t;objHasOwnProperty(e,DynProtoBaseProto)||(delete e[DynProtoCurrent],n=e[DynProtoBaseProto]=e[DynProtoCurrent]||e[DynProtoBaseProto],e[DynProtoCurrent]=t)}return n}function _forEachProp(e,t){var n=[];if(_objGetOwnProps)n=_objGetOwnProps(e);else for(var r in e)"string"==typeof r&&objHasOwnProperty(e,r)&&n.push(r);if(n&&0<n.length)for(var o=0;o<n.length;o++)t(n[o])}function _isDynamicCandidate(e,t,n){return t!==Constructor&&typeof e[t]===strFunction&&(n||objHasOwnProperty(e,t))&&t!==str__Proto&&t!==Prototype}function _throwTypeError(e){throwTypeError("DynamicProto: "+e)}function _getInstanceFuncs(t){var n=objCreate(null);return _forEachProp(t,function(e){!n[e]&&_isDynamicCandidate(t,e,!1)&&(n[e]=t[e])}),n}function _hasVisited(e,t){for(var n=e.length-1;0<=n;n--)if(e[n]===t)return!0;return!1}function _getBaseFuncs(e,t,n,a){function r(e,t,n){var r,o=t[n];return o[DynProxyTag]&&a&&!1!==(r=e[DynInstFuncTable]||{})[DynAllowInstChkTag]&&(o=(r[t[DynClassName]]||{})[n]||o),function(){return o.apply(e,arguments)}}for(var o=objCreate(null),i=(_forEachProp(n,function(e){o[e]=r(t,n,e)}),_getObjProto(e)),_=[];i&&!_isObjectArrayOrFunctionPrototype(i)&&!_hasVisited(_,i);)_forEachProp(i,function(e){!o[e]&&_isDynamicCandidate(i,e,!_objGetPrototypeOf)&&(o[e]=r(t,i,e))}),_.push(i),i=_getObjProto(i);return o}function _getInstFunc(e,t,n,r){var o=null;if(e&&objHasOwnProperty(n,DynClassName)){var a=e[DynInstFuncTable]||objCreate(null);if((o=(a[n[DynClassName]]||objCreate(null))[t])||_throwTypeError("Missing ["+t+"] "+strFunction),!o[DynInstChkTag]&&!1!==a[DynAllowInstChkTag]){for(var i=!objHasOwnProperty(e,t),_=_getObjProto(e),u=[];i&&_&&!_isObjectArrayOrFunctionPrototype(_)&&!_hasVisited(u,_);){var c=_[t];if(c){i=c===r;break}u.push(_),_=_getObjProto(_)}try{i&&(e[t]=o),o[DynInstChkTag]=1}catch(s){a[DynAllowInstChkTag]=!1}}}return o}function _getProtoFunc(e,t,n){var r=t[e];return typeof(r=r===n?_getObjProto(t)[e]:r)!==strFunction&&_throwTypeError("["+e+"] is not a "+strFunction),r}function _populatePrototype(o,e,a,i,t){var n,_;_isObjectOrArrayPrototype(o)||_isObjectOrArrayPrototype(n=a[DynInstFuncTable]=a[DynInstFuncTable]||objCreate(null))||(_=n[e]=n[e]||objCreate(null),!1!==n[DynAllowInstChkTag]&&(n[DynAllowInstChkTag]=!!t),_isObjectOrArrayPrototype(_)||_forEachProp(a,function(e){var t,n,r;_isDynamicCandidate(a,e,!1)&&a[e]!==i[e]&&(_[e]=a[e],delete a[e],objHasOwnProperty(o,e)&&(!o[e]||o[e][DynProxyTag])||(o[e]=(t=o,n=e,(r=function(){return(_getInstFunc(this,n,t,r)||_getProtoFunc(n,t,r)).apply(this,arguments)})[DynProxyTag]=1,r)))}))}function _checkPrototype(e,t){if(_objGetPrototypeOf){for(var n=[],r=_getObjProto(t);r&&!_isObjectArrayOrFunctionPrototype(r)&&!_hasVisited(n,r);){if(r===e)return!0;n.push(r),r=_getObjProto(r)}return!1}return!0}function _getObjName(e,t){return objHasOwnProperty(e,Prototype)?e.name||t||UnknownValue:((e||{})[Constructor]||{}).name||t||UnknownValue}function dynamicProto(e,t,n,r){objHasOwnProperty(e,Prototype)||_throwTypeError("theClass is an invalid class definition.");var o=e[Prototype],a=(_checkPrototype(o,t)||_throwTypeError("["+_getObjName(e)+"] not in hierarchy of ["+_getObjName(t)+"]"),null),e=(objHasOwnProperty(o,DynClassName)?a=o[DynClassName]:(a=DynClassNamePrefix+_getObjName(e,"_")+"$"+_gblInst.n,_gblInst.n++,o[DynClassName]=a),dynamicProto[DynProtoDefaultOptions]),i=!!e[strUseBaseInst],_=(i&&r&&r[strUseBaseInst]!==undefined&&(i=!!r[strUseBaseInst]),_getInstanceFuncs(t)),i=(n(t,_getBaseFuncs(o,t,_,i)),!!_objGetPrototypeOf&&!!e[strSetInstFuncs]);_populatePrototype(o,a,t,_,!1!==(i=i&&r?!!r[strSetInstFuncs]:i))}dynamicProto[DynProtoDefaultOptions]=_gblInst.o;var aggregationErrorType,_DYN_TO_LOWER_CASE="toLowerCase",_DYN_LENGTH="length",_DYN_WARN_TO_CONSOLE="warnToConsole",_DYN_THROW_INTERNAL="throwInternal",_DYN_WATCH="watch",_DYN_APPLY="apply",_DYN_PUSH="push",_DYN_SPLICE="splice",_DYN_LOGGER="logger",_DYN_CANCEL="cancel",_DYN_INITIALIZE="initialize",_DYN_IDENTIFIER="identifier",_DYN_IS_INITIALIZED="isInitialized",_DYN_GET_PLUGIN="getPlugin",_DYN_NAME="name",_DYN_PROCESS_NEXT="processNext",_DYN_GET_PROCESS_TEL_CONT2="getProcessTelContext",_DYN_UNLOAD="unload",_DYN_LOGGING_LEVEL_CONSOL4="loggingLevelConsole",_DYN_CREATE_NEW="createNew",_DYN_TEARDOWN="teardown",_DYN_MESSAGE_ID="messageId",_DYN_MESSAGE="message",_DYN_DIAG_LOG="diagLog",_DYN__DO_TEARDOWN="_doTeardown",_DYN_UPDATE="update",_DYN_GET_NEXT="getNext",_DYN_SET_NEXT_PLUGIN="setNextPlugin",_DYN_USER_AGENT="userAgent",_DYN_SPLIT="split",_DYN_REPLACE="replace",_DYN_TYPE="type",_DYN_EVT_NAME="evtName",_DYN_IS_CHILD_EVT="isChildEvt",_DYN_GET_CTX="getCtx",_DYN_SET_CTX="setCtx";function throwAggregationError(e,t){aggregationErrorType=aggregationErrorType||createCustomError("AggregationError",function(e,t){1<t[_DYN_LENGTH]&&(e.errors=t[1])});var n=e||"One or more errors occurred.";throw arrForEach(t,function(e,t){n+="\n".concat(t," > ").concat(dumpObj(e))}),new aggregationErrorType(n,t||[])}var REJECTED="rejected";function doAwaitResponse(e,t){return doAwait(e,function(e){return t?t({status:"fulfilled",rejected:!1,value:e}):e},function(e){return t?t({status:REJECTED,rejected:!0,reason:e}):e})}function doAwait(e,t,n,r){var o=e;try{if(isPromiseLike(e))(t||n)&&(o=e.then(t,n));else try{t&&(o=t(e))}catch(a){if(!n)throw a;o=n(a)}}finally{r&&doFinally(o,r)}return o}function doFinally(e,t){var n=e;return t&&(isPromiseLike(e)?n=e["finally"]?e["finally"](t):e.then(function(e){return t(),e},function(e){throw t(),e}):t()),n}var UNDEFINED_VALUE=undefined,STR_EMPTY="",STR_CORE="core",STR_DISABLED="disabled",STR_EXTENSION_CONFIG="extensionConfig",STR_PROCESS_TELEMETRY="processTelemetry",STR_PRIORITY="priority",STR_GET_PERF_MGR="getPerfMgr",STR_NOT_DYNAMIC_ERROR="Not dynamic - ",rCamelCase=/-([a-z])/g,rNormalizeInvalid=/([^\w\d_$])/g,rLeadingNumeric=/^(\d+[\w\d_$])/;function isNotNullOrUndefined(e){return!isNullOrUndefined(e)}function normalizeJsName(e){return e&&isString(e)?(e=(e=e[_DYN_REPLACE](rCamelCase,function(e,t){return t.toUpperCase()}))[_DYN_REPLACE](rNormalizeInvalid,"_"))[_DYN_REPLACE](rLeadingNumeric,function(e,t){return"_"+t}):e}function strContains(e,t){return!(!e||!t)&&-1!==strIndexOf(e,t)}function _createProxyFunction(e,t){var n=null,r=null;return isFunction(e)?n=e:r=e,function(){var e=arguments;if(r=n?n():r)return r[t][_DYN_APPLY](r,e)}}function proxyFunctionAs(e,t,n,r,o){e&&t&&n&&(!1===o&&!isUndefined(e[t])||(e[t]=_createProxyFunction(n,r)))}var strConsole="console",strJSON="JSON",strCrypto="crypto",strMsCrypto="msCrypto",strMsie="msie",strTrident="trident/",strXMLHttpRequest="XMLHttpRequest",_isTrident=null,_navUserAgentCheck=null;function _hasProperty(e,t){var n,r=!1;if(e){try{(r=t in e)||(n=e[strShimPrototype])&&(r=t in n)}catch(o){}if(!r)try{r=!isUndefined((new e)[t])}catch(o){}}return r}function getConsole(){return typeof console!==strShimUndefined?console:getInst(strConsole)}function hasJSON(){return!!(typeof JSON===strShimObject&&JSON||null!==getInst(strJSON))}function getJSON(){return hasJSON()?JSON||getInst(strJSON):null}function getCrypto(){return getInst(strCrypto)}function getMsCrypto(){return getInst(strMsCrypto)}function isIE(){var e=getNavigator();return!e||e[_DYN_USER_AGENT]===_navUserAgentCheck&&null!==_isTrident||(e=((_navUserAgentCheck=e[_DYN_USER_AGENT])||STR_EMPTY)[_DYN_TO_LOWER_CASE](),_isTrident=strContains(e,strMsie)||strContains(e,strTrident)),_isTrident}function isFetchSupported(e){var t=!1;try{var t=!!getInst("fetch"),n=getInst("Request");t&&e&&n&&(t=_hasProperty(n,"keepalive"))}catch(r){}return t}function isXhrSupported(){var e=!1;try{e=!!getInst(strXMLHttpRequest)}catch(t){}return e}function dispatchEvent(e,t){return!!(e&&e.dispatchEvent&&t)&&(e.dispatchEvent(t),!0)}function createCustomDomEvent(e,t){var n,r=null,t={detail:t||null};return isFunction(CustomEvent)?r=new CustomEvent(e,t):(n=getDocument())&&n.createEvent&&(r=n.createEvent("CustomEvent")).initCustomEvent(e,!0,!0,t),r}function sendCustomEvent(e,t,n){var r=getGlobal();if(r&&r.CustomEvent)try{return dispatchEvent(r,createCustomDomEvent(e,{cfg:t||null,customDetails:n||null}))}catch(o){}return!1}var UInt32Mask=4294967296,MaxUInt32=4294967295,SEED1=123456789,SEED2=987654321,_mwcSeeded=!1,_mwcW=SEED1,_mwcZ=SEED2;function _mwcSeed(e){e<0&&(e>>>=0),_mwcW=SEED1+e&MaxUInt32,_mwcZ=SEED2-e&MaxUInt32,_mwcSeeded=!0}function _autoSeedMwc(){try{var e=2147483647&utcNow();_mwcSeed((Math.random()*UInt32Mask^e)+e)}catch(t){}}function random32(e){var t=0,n=getCrypto()||getMsCrypto();return 0===(t=n&&n.getRandomValues?n.getRandomValues(new Uint32Array(1))[0]&MaxUInt32:t)&&isIE()&&(_mwcSeeded||_autoSeedMwc(),t=mwcRandom32()&MaxUInt32),0===t&&(t=mathFloor(UInt32Mask*Math.random()|0)),e||(t>>>=0),t}function mwcRandom32(e){var t=((_mwcZ=36969*(65535&_mwcZ)+(_mwcZ>>16)&MaxUInt32)<<16)+(65535&(_mwcW=18e3*(65535&_mwcW)+(_mwcW>>16)&MaxUInt32))>>>0&MaxUInt32|0;return e||(t>>>=0),t}function newId(e){void 0===e&&(e=22);for(var t=random32()>>>0,n=0,r=STR_EMPTY;r[_DYN_LENGTH]<e;)r+="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"[0|63&t]||"",t>>>=6,5==++n&&(t=(random32()<<2&4294967295|3&t)>>>0,n=0);return r}var version="3.3.8",instanceName="."+newId(6),_dataUid=0;function _canAcceptData(e){return 1===e.nodeType||9===e.nodeType||!+e.nodeType}function _getCache(e,t){var n=t[e.id];if(!n){n={};try{_canAcceptData(t)&&objDefine(t,e.id,{e:!1,v:n})}catch(r){}}return n}function createUniqueNamespace(e,t){return normalizeJsName(e+_dataUid+++((t=void 0!==t&&t)?"."+version:STR_EMPTY)+instanceName)}function createElmNodeData(e){var a={id:createUniqueNamespace("_aiData-"+(e||STR_EMPTY)+"."+version),accept:function(e){return _canAcceptData(e)},get:function(e,t,n,r){var o=e[a.id];return o?o[normalizeJsName(t)]:(r&&((o=_getCache(a,e))[normalizeJsName(t)]=n),n)},kill:function(e,t){if(e&&e[t])try{delete e[t]}catch(n){}}};return a}function _isConfigDefaults(e){return e&&isObject(e)&&!isArray(e)&&(e.isVal||e.fb||objHasOwn(e,"v")||objHasOwn(e,"mrg")||objHasOwn(e,"ref")||e.set)}function _getDefault(e,t,n){var r,o=n.dfVal||isDefined;if(t&&n.fb){var a=n.fb;isArray(a)||(a=[a]);for(var i=0;i<a[_DYN_LENGTH];i++){var _=a[i],u=t[_];if(o(u)?r=u:e&&(o(u=e.cfg[_])&&(r=u),e.set(e.cfg,asString(_),u)),o(r))break}}return!o(r)&&o(n.v)?n.v:r}function _resolveDefaultValue(n,r,e){var o,t=e;return(t=e&&_isConfigDefaults(e)?_getDefault(n,r,e):t)&&(_isConfigDefaults(t)&&(t=_resolveDefaultValue(n,r,t)),isArray(t)?(o=[])[_DYN_LENGTH]=t[_DYN_LENGTH]:isPlainObject(t)&&(o={}),o&&(objForEachKey(t,function(e,t){t&&_isConfigDefaults(t)&&(t=_resolveDefaultValue(n,r,t)),o[e]=t}),t=o)),t}function _applyDefaultValue(n,e,t,r){var o,a,i,_,u,c,s=r,s=_isConfigDefaults(s)?(o=s.isVal,a=s.set,u=s.rdOnly,l=s.blkVal,i=s.mrg,!(_=s.ref)&&isUndefined(_)&&(_=!!i),_getDefault(n,e,s)):r,r=(l&&n.blkVal(e,t),!0),l=e[t];!l&&isNullOrUndefined(l)||(c=l,r=!1,o&&c!==s&&!o(c)&&(c=s,r=!0),a&&(r=(c=a(c,s,e))===s)),r?c=s&&_resolveDefaultValue(n,e,s):(isPlainObject(c)||isArray(s))&&i&&s&&(isPlainObject(s)||isArray(s))&&objForEachKey(s,function(e,t){_applyDefaultValue(n,c,e,t)}),n.set(e,t,c),_&&n.ref(e,t),u&&n.rdOnly(e,t)}var CFG_HANDLER_LINK=symbolFor("[[ai_dynCfg_1]]"),BLOCK_DYNAMIC=symbolFor("[[ai_blkDynCfg_1]]"),FORCE_DYNAMIC=symbolFor("[[ai_frcDynCfg_1]]");function _cfgDeepCopy(e){var n;return e&&(isArray(e)?(n=[])[_DYN_LENGTH]=e[_DYN_LENGTH]:isPlainObject(e)&&(n={}),n)?(objForEachKey(e,function(e,t){n[e]=_cfgDeepCopy(t)}),n):e}function getDynamicConfigHandler(e){if(e){var t=e[CFG_HANDLER_LINK]||e;if(t.cfg&&(t.cfg===e||t.cfg[CFG_HANDLER_LINK]===t))return t}return null}function blockDynamicConversion(e){if(e&&(isPlainObject(e)||isArray(e)))try{e[BLOCK_DYNAMIC]=!0}catch(t){}return e}function _canMakeDynamic(e,t,n){var r=!1;return!n||e[t.blkVal]||(r=n[FORCE_DYNAMIC])||n[BLOCK_DYNAMIC]?r:isPlainObject(n)||isArray(n)}function throwInvalidAccess(e){throwTypeError("InvalidAccess:"+e)}var arrayMethodsToPatch=["push","pop","shift","unshift","splice"],_throwDynamicError=function(e,t,n,r){e&&e[_DYN_THROW_INTERNAL](3,108,"".concat(n," [").concat(t,"] failed - ")+dumpObj(r))};function _patchArray(o,a,i){isArray(a)&&arrForEach(arrayMethodsToPatch,function(e){var r=a[e];a[e]=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var n=r[_DYN_APPLY](this,e);return _makeDynamicObject(o,a,i,"Patching"),n}})}function _getOwnPropGetter(e,t){e=objGetOwnPropertyDescriptor(e,t);return e&&e.get}function _createDynamicProperty(o,a,i,_){var u={n:i,h:[],trk:function(e){e&&e.fn&&(-1===arrIndexOf(u.h,e)&&u.h[_DYN_PUSH](e),o.trk(e,u))},clr:function(e){e=arrIndexOf(u.h,e);-1!==e&&u.h[_DYN_SPLICE](e,1)}},c=!0,s=!1;function l(){c&&(s=s||_canMakeDynamic(l,o,_),_&&!_[CFG_HANDLER_LINK]&&s&&(_=_makeDynamicObject(o,_,i,"Converting")),c=!1);var e=o.act;return e&&u.trk(e),_}l[o.prop]={chng:function(){o.add(u)}},objDefine(a,u.n,{g:l,s:function(t){if(_!==t){l[o.ro]&&!o.upd&&throwInvalidAccess("["+i+"] is read-only:"+dumpObj(a)),c&&(s=s||_canMakeDynamic(l,o,_),c=!1);var e,n=s&&l[o.rf];if(s)if(n){objForEachKey(_,function(e){_[e]=t?t[e]:UNDEFINED_VALUE});try{objForEachKey(t,function(e,t){_setDynamicProperty(o,_,e,t)}),t=_}catch(r){_throwDynamicError((o.hdlr||{})[_DYN_LOGGER],i,"Assigning",r),s=!1}}else _&&_[CFG_HANDLER_LINK]&&objForEachKey(_,function(e){var e=_getOwnPropGetter(_,e);e&&(e=e[o.prop])&&e.chng()});t!==_&&(e=t&&_canMakeDynamic(l,o,t),!n&&e&&(t=_makeDynamicObject(o,t,i,"Converting")),_=t,s=e),o.add(u)}}})}function _setDynamicProperty(e,t,n,r){var o;return t&&((o=_getOwnPropGetter(t,n))&&o[e.prop]?t[n]=r:_createDynamicProperty(e,t,n,r)),t}function _setDynamicPropertyState(e,t,n,r){if(t){var o=_getOwnPropGetter(t,n),a=o&&!!o[e.prop],i=r&&r[0],_=r&&r[1],r=r&&r[2];if(!a){if(r)try{blockDynamicConversion(t)}catch(u){_throwDynamicError((e.hdlr||{})[_DYN_LOGGER],n,"Blocking",u)}try{_setDynamicProperty(e,t,n,t[n]),o=_getOwnPropGetter(t,n)}catch(u){_throwDynamicError((e.hdlr||{})[_DYN_LOGGER],n,"State",u)}}i&&(o[e.rf]=i),_&&(o[e.ro]=_),r&&(o[e.blkVal]=!0)}return t}function _makeDynamicObject(n,r,e,t){try{objForEachKey(r,function(e,t){_setDynamicProperty(n,r,e,t)}),r[CFG_HANDLER_LINK]||(objDefineProp(r,CFG_HANDLER_LINK,{get:function(){return n.hdlr}}),_patchArray(n,r,e))}catch(o){_throwDynamicError((n.hdlr||{})[_DYN_LOGGER],e,t,o)}return r}var symPrefix="[[ai_",symPostfix="]]";function _createState(a){var i,e=newSymbol(symPrefix+"get"+a.uid+symPostfix),t=newSymbol(symPrefix+"ro"+a.uid+symPostfix),n=newSymbol(symPrefix+"rf"+a.uid+symPostfix),r=newSymbol(symPrefix+"blkVal"+a.uid+symPostfix),_=newSymbol(symPrefix+"dtl"+a.uid+symPostfix),o=null,u=null;function c(t,e){var n=i.act;try{(i.act=t)&&t[_]&&(arrForEach(t[_],function(e){e.clr(t)}),t[_]=[]),e({cfg:a.cfg,set:a.set.bind(a),setDf:a.setDf.bind(a),ref:a.ref.bind(a),rdOnly:a.rdOnly.bind(a)})}catch(o){var r=a[_DYN_LOGGER];throw r&&r[_DYN_THROW_INTERNAL](1,107,dumpObj(o)),o}finally{i.act=n||null}}function s(){if(o){var e=o,n=(o=null,u&&u[_DYN_CANCEL](),u=null,[]);if(arrForEach(e,function(t){if(t&&(t[_]&&(arrForEach(t[_],function(e){e.clr(t)}),t[_]=null),t.fn))try{c(t,t.fn)}catch(e){n[_DYN_PUSH](e)}}),o)try{s()}catch(t){n[_DYN_PUSH](t)}0<n[_DYN_LENGTH]&&throwAggregationError("Watcher error(s): ",n)}}return i={prop:e,ro:t,rf:n,blkVal:r,hdlr:a,add:function(e){if(e&&0<e.h[_DYN_LENGTH]){o=o||[],u=u||scheduleTimeout(function(){u=null,s()},0);for(var t=0;t<e.h[_DYN_LENGTH];t++){var n=e.h[t];n&&-1===arrIndexOf(o,n)&&o[_DYN_PUSH](n)}}},notify:s,use:c,trk:function(e,t){e&&(e=e[_]=e[_]||[],-1===arrIndexOf(e,t)&&e[_DYN_PUSH](t))}}}function _createAndUseHandler(e,t){var n={fn:t,rm:function(){n.fn=null,t=e=null}};return objDefine(n,"toJSON",{v:function(){return"WatcherHandler"+(n.fn?"":"[X]")}}),e.use(n,t),n}function _createDynamicHandler(o,e,t){var n=getDynamicConfigHandler(e);if(n)return n;var a,n=createUniqueNamespace("dyncfg",!0),t=e&&!1!==t?e:_cfgDeepCopy(e),r={uid:null,cfg:t,logger:o,notify:function(){a.notify()},set:function(e,t,n){try{e=_setDynamicProperty(a,e,t,n)}catch(r){_throwDynamicError(o,t,"Setting value",r)}return e[t]},setDf:function(n,e){return e&&objForEachKey(e,function(e,t){_applyDefaultValue(r,n,e,t)}),n},watch:function(e){return _createAndUseHandler(a,e)},ref:function(e,t){return _setDynamicPropertyState(a,e,t,((e={})[0]=!0,e))[t]},rdOnly:function(e,t){return _setDynamicPropertyState(a,e,t,((e={})[1]=!0,e))[t]},blkVal:function(e,t){return _setDynamicPropertyState(a,e,t,((e={})[2]=!0,e))[t]},_block:function(n,r){a.use(null,function(e){var t=a.upd;try{isUndefined(r)||(a.upd=r),n(e)}finally{a.upd=t}})}};return objDefine(r,"uid",{c:!1,e:!1,w:!1,v:n}),_makeDynamicObject(a=_createState(r),t,"config","Creating"),r}function _logInvalidAccess(e,t){e?(e[_DYN_WARN_TO_CONSOLE](t),e[_DYN_THROW_INTERNAL](2,108,t)):throwInvalidAccess(t)}function createDynamicConfig(e,t,n,r){n=_createDynamicHandler(n,e||{},r);return t&&n.setDf(n.cfg,t),n}function onConfigChange(e,t,n){var r=e[CFG_HANDLER_LINK]||e;return!r.cfg||r.cfg!==e&&r.cfg[CFG_HANDLER_LINK]!==r?(_logInvalidAccess(n,STR_NOT_DYNAMIC_ERROR+dumpObj(e)),createDynamicConfig(e,null,n)[_DYN_WATCH](t)):r[_DYN_WATCH](t)}var _a$2,_aiNamespace=null;function _getExtensionNamespace(){var e=getInst("Microsoft");return _aiNamespace=e?e.ApplicationInsights:_aiNamespace}function getDebugExt(e){var t=_aiNamespace;return(t=t||!0===e.disableDbgExt?t:_aiNamespace||_getExtensionNamespace())?t.ChromeDbgExt:null}var STR_WARN_TO_CONSOLE="warnToConsole",AiNonUserActionablePrefix="AI (Internal): ",AiUserActionablePrefix="AI: ",AIInternalMessagePrefix="AITR_",defaultValues$1={loggingLevelConsole:0,loggingLevelTelemetry:1,maxMessageLimit:25,enableDebug:!1},_logFuncs=((_a$2={})[0]=null,_a$2[1]="errorToConsole",_a$2[2]=STR_WARN_TO_CONSOLE,_a$2[3]="debugToConsole",_a$2);function _sanitizeDiagnosticText(e){return e?'"'+e[_DYN_REPLACE](/\"/g,STR_EMPTY)+'"':STR_EMPTY}function _logToConsole(e,t){var n,r=getConsole();r&&(n="log",r[e]&&(n=e),isFunction(r[n])&&r[n](t))}var _InternalLogMessage=function(){function e(e,t,n,r){void 0===n&&(n=!1),this[_DYN_MESSAGE_ID]=e,this[_DYN_MESSAGE]=(n?AiUserActionablePrefix:AiNonUserActionablePrefix)+e;n=STR_EMPTY,hasJSON()&&(n=getJSON().stringify(r)),e=(t?" message:"+_sanitizeDiagnosticText(t):STR_EMPTY)+(r?" props:"+_sanitizeDiagnosticText(n):STR_EMPTY);this[_DYN_MESSAGE]+=e}return e.dataType="MessageData",e}();function safeGetLogger(e,t){return(e||{})[_DYN_LOGGER]||new DiagnosticLogger(t)}var DiagnosticLogger=function(){function e(r){this.identifier="DiagnosticLogger",this.queue=[];var u,o,c,s,t,l=0,f={};dynamicProto(e,this,function(a){function i(e,t){var n,r;c<=l||(r=!0,n=AIInternalMessagePrefix+t[_DYN_MESSAGE_ID],f[n]?r=!1:f[n]=!0,r&&(e<=o&&(a.queue[_DYN_PUSH](t),l++,_(1===e?"error":"warn",t)),l===c&&(r=new _InternalLogMessage(23,n="Internal events throttle limit per PageView reached for this app.",!1),a.queue[_DYN_PUSH](r),1===e?a.errorToConsole(n):a[_DYN_WARN_TO_CONSOLE](n))))}function _(e,t){var n=getDebugExt(r||{});n&&n[_DYN_DIAG_LOG]&&n[_DYN_DIAG_LOG](e,t)}t=onConfigChange(createDynamicConfig(r||{},defaultValues$1,a).cfg,function(e){e=e.cfg;u=e[_DYN_LOGGING_LEVEL_CONSOL4],o=e.loggingLevelTelemetry,c=e.maxMessageLimit,s=e.enableDebug}),a.consoleLoggingLevel=function(){return u},a[_DYN_THROW_INTERNAL]=function(e,t,n,r,o){t=new _InternalLogMessage(t,n,o=void 0!==o&&o,r);if(s)throw dumpObj(t);n=_logFuncs[e]||STR_WARN_TO_CONSOLE;isUndefined(t[_DYN_MESSAGE])?_("throw"+(1===e?"Critical":"Warning"),t):(o?(r=+t[_DYN_MESSAGE_ID],!f[r]&&e<=u&&(a[n](t[_DYN_MESSAGE]),f[r]=!0)):e<=u&&a[n](t[_DYN_MESSAGE]),i(e,t))},a.debugToConsole=function(e){_logToConsole("debug",e),_("warning",e)},a[_DYN_WARN_TO_CONSOLE]=function(e){_logToConsole("warn",e),_("warning",e)},a.errorToConsole=function(e){_logToConsole("error",e),_("error",e)},a.resetInternalMessageCount=function(){l=0,f={}},a.logInternalMessage=i,a[_DYN_UNLOAD]=function(e){t&&t.rm(),t=null}})}return e.__ieDyn=1,e}();function _getLogger(e){return e||new DiagnosticLogger}function _throwInternal(e,t,n,r,o,a){void 0===a&&(a=!1),_getLogger(e)[_DYN_THROW_INTERNAL](t,n,r,o,a)}var strExecutionContextKey="ctx",strParentContextKey="ParentContextKey",strChildrenContextKey="ChildrenContextKey",PerfEvent=function(){function a(e,t,n){var r,o=this;o.start=utcNow(),o[_DYN_NAME]=e,o.isAsync=n,o[_DYN_IS_CHILD_EVT]=function(){return!1},isFunction(t)&&objDefine(o,"payload",{g:function(){return!r&&isFunction(t)&&(r=t(),t=null),r}}),o[_DYN_GET_CTX]=function(e){return e?(e===a[strParentContextKey]||e===a[strChildrenContextKey]?o:o[strExecutionContextKey]||{})[e]:null},o[_DYN_SET_CTX]=function(e,t){e&&(e===a[strParentContextKey]?(o[e]||(o[_DYN_IS_CHILD_EVT]=function(){return!0}),o[e]=t):e===a[strChildrenContextKey]?o[e]=t:(o[strExecutionContextKey]=o[strExecutionContextKey]||{})[e]=t)},o.complete=function(){var e=0,t=o[_DYN_GET_CTX](a[strChildrenContextKey]);if(isArray(t))for(var n=0;n<t[_DYN_LENGTH];n++){var r=t[n];r&&(e+=r.time)}o.time=utcNow()-o.start,o.exTime=o.time-e,o.complete=function(){}}}return a.ParentContextKey="parent",a.ChildrenContextKey="childEvts",a}(),doPerfActiveKey="CoreUtils.doPerf";function doPerf(e,t,n,r,o){if(e)if(e=e[STR_GET_PERF_MGR]?e[STR_GET_PERF_MGR]():e){var a,i=void 0,_=e[_DYN_GET_CTX](doPerfActiveKey);try{if(i=e.create(t(),r,o))return _&&i[_DYN_SET_CTX]&&(i[_DYN_SET_CTX](PerfEvent[strParentContextKey],_),_[_DYN_GET_CTX]&&_[_DYN_SET_CTX]&&((a=_[_DYN_GET_CTX](PerfEvent[strChildrenContextKey]))||(a=[],_[_DYN_SET_CTX](PerfEvent[strChildrenContextKey],a)),a[_DYN_PUSH](i))),e[_DYN_SET_CTX](doPerfActiveKey,i),n(i)}catch(u){i&&i[_DYN_SET_CTX]&&i[_DYN_SET_CTX]("exception",u)}finally{i&&e.fire(i),e[_DYN_SET_CTX](doPerfActiveKey,_)}}return n()}var pluginStateData=createElmNodeData("plugin");function _getPluginState(e){return pluginStateData.get(e,"state",{},!0)}var _a$1,strTelemetryPluginChain="TelemetryPluginChain",strHasRunFlags="_hasRun",strGetTelCtx="_getTelCtx",_chainId=0;function _getNextProxyStart(e,t,n){for(;e;){if(e[_DYN_GET_PLUGIN]()===n)return e;e=e[_DYN_GET_NEXT]()}return createTelemetryProxyChain([n],t.config||{},t)}function _createInternalContext(e,a,n,t){var r=null,o=[],i=(a=a||createDynamicConfig({},null,n[_DYN_LOGGER]),null!==t&&(r=t?_getNextProxyStart(e,n,t):e),{_next:function(){var e,t=r;return r=t?t[_DYN_GET_NEXT]():null,t||(e=o)&&0<e[_DYN_LENGTH]&&(arrForEach(e,function(e){try{e.func.call(e.self,e.args)}catch(t){_throwInternal(n[_DYN_LOGGER],2,73,"Unexpected Exception during onComplete - "+dumpObj(t))}}),o=[]),t},ctx:{core:function(){return n},diagLog:function(){return safeGetLogger(n,a.cfg)},getCfg:function(){return a.cfg},getExtCfg:function(e,t){var r=_(e,!0);return t&&objForEachKey(t,function(e,t){var n;!isNullOrUndefined(r[e])||!(n=a.cfg[e])&&isNullOrUndefined(n)||(r[e]=n),_applyDefaultValue(a,r,e,t)}),a.setDf(r,t)},getConfig:function(e,t,n){void 0===n&&(n=!1);var r,e=_(e,!1),o=a.cfg;return!e||!e[t]&&isNullOrUndefined(e[t])?!o[t]&&isNullOrUndefined(o[t])||(r=o[t]):r=e[t],r||!isNullOrUndefined(r)?r:n},hasNext:function(){return!!r},getNext:function(){return r},setNext:function(e){r=e},iterate:function(e){for(;t=i._next();){var t=t[_DYN_GET_PLUGIN]();t&&e(t)}},onComplete:function(e,t){for(var n=[],r=2;r<arguments.length;r++)n[r-2]=arguments[r];e&&o[_DYN_PUSH]({func:e,self:isUndefined(t)?i.ctx:t,args:n})}}});function _(e,t){var n,r=null,o=a.cfg;return o&&e&&(n=o[STR_EXTENSION_CONFIG],o[STR_EXTENSION_CONFIG]=n=!n&&t?{}:n,(n=a.ref(o,STR_EXTENSION_CONFIG))&&(r=n[e],n[e]=r=!r&&t?{}:r,r=a.ref(n,e))),r}return i}function createProcessTelemetryContext(e,t,n,r){var o=createDynamicConfig(t),a=_createInternalContext(e,o,n,r),i=a.ctx;return i[_DYN_PROCESS_NEXT]=function(e){var t=a._next();return t&&t[STR_PROCESS_TELEMETRY](e,i),!t},i[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,o.cfg,n,t):e)||i[_DYN_GET_NEXT](),o.cfg,n,t)},i}function createProcessTelemetryUnloadContext(e,n,t){var r=createDynamicConfig(n.config),o=_createInternalContext(e,r,n,t),a=o.ctx;return a[_DYN_PROCESS_NEXT]=function(e){var t=o._next();return t&&t[_DYN_UNLOAD](a,e),!t},a[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryUnloadContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,r.cfg,n,t):e)||a[_DYN_GET_NEXT](),n,t)},a}function createProcessTelemetryUpdateContext(e,n,t){var r=createDynamicConfig(n.config),o=_createInternalContext(e,r,n,t).ctx;return o[_DYN_PROCESS_NEXT]=function(t){return o.iterate(function(e){isFunction(e[_DYN_UPDATE])&&e[_DYN_UPDATE](o,t)})},o[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryUpdateContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,r.cfg,n,t):e)||o[_DYN_GET_NEXT](),n,t)},o}function createTelemetryProxyChain(e,t,n,r){var o,a=null,i=!r;return isArray(e)&&0<e[_DYN_LENGTH]&&(o=null,arrForEach(e,function(e){(i=!i&&r===e||i)&&e&&isFunction(e[STR_PROCESS_TELEMETRY])&&(e=createTelemetryPluginProxy(e,t,n),a=a||e,o&&o._setNext(e),o=e)})),r&&!a?createTelemetryProxyChain([r],t,n):a}function createTelemetryPluginProxy(u,r,o){var c=null,a=isFunction(u[STR_PROCESS_TELEMETRY]),i=isFunction(u[_DYN_SET_NEXT_PLUGIN]),s=u?u[_DYN_IDENTIFIER]+"-"+u[STR_PRIORITY]+"-"+_chainId++:"Unknown-0-"+_chainId++,_={getPlugin:function(){return u},getNext:function(){return c},processTelemetry:function(n,e){var t;l(e=e||(t=(t=u&&isFunction(u[strGetTelCtx])?u[strGetTelCtx]():t)||createProcessTelemetryContext(_,r,o)),function(e){if(!u||!a)return!1;var t=_getPluginState(u);return!t[_DYN_TEARDOWN]&&!t[STR_DISABLED]&&(i&&u[_DYN_SET_NEXT_PLUGIN](c),u[STR_PROCESS_TELEMETRY](n,e),!0)},"processTelemetry",function(){return{item:n}},!n.sync)||e[_DYN_PROCESS_NEXT](n)},unload:function(r,o){l(r,function(){var e,t,n=!1;return u&&(e=_getPluginState(u),t=u[STR_CORE]||e[STR_CORE],!u||t&&t!==r.core()||e[_DYN_TEARDOWN]||(e[STR_CORE]=null,e[_DYN_TEARDOWN]=!0,e[_DYN_IS_INITIALIZED]=!1,u[_DYN_TEARDOWN]&&!0===u[_DYN_TEARDOWN](r,o)&&(n=!0))),n},"unload",function(){},o.isAsync)||r[_DYN_PROCESS_NEXT](o)},update:function(r,o){l(r,function(){var e,t,n=!1;return u&&(e=_getPluginState(u),t=u[STR_CORE]||e[STR_CORE],!u||t&&t!==r.core()||e[_DYN_TEARDOWN]||u[_DYN_UPDATE]&&!0===u[_DYN_UPDATE](r,o)&&(n=!0)),n},"update",function(){},!1)||r[_DYN_PROCESS_NEXT](o)},_id:s,_setNext:function(e){c=e}};function l(n,r,o,e,t){var a=!1,i=u?u[_DYN_IDENTIFIER]:strTelemetryPluginChain,_=(_=n[strHasRunFlags])||(n[strHasRunFlags]={});return n.setNext(c),u&&doPerf(n[STR_CORE](),function(){return i+":"+o},function(){_[s]=!0;try{var e=c?c._id:STR_EMPTY;e&&(_[e]=!1),a=r(n)}catch(t){e=!c||_[c._id];e&&(a=!0),c&&e||_throwInternal(n[_DYN_DIAG_LOG](),1,73,"Plugin ["+i+"] failed during "+o+" - "+dumpObj(t)+", run flags: "+dumpObj(_))}},e,t),a}return objFreeze(_)}function createUnloadHandlerContainer(){var t=[];return{add:function(e){e&&t[_DYN_PUSH](e)},run:function(n,r){arrForEach(t,function(e){try{e(n,r)}catch(t){_throwInternal(n[_DYN_DIAG_LOG](),2,73,"Unexpected error calling unload handler - "+dumpObj(t))}}),t=[]}}}function createUnloadHookContainer(){var t=[];return{run:function(n){var e=t;t=[],arrForEach(e,function(e){try{(e.rm||e.remove).call(e)}catch(t){_throwInternal(n,2,73,"Unloading:"+dumpObj(t))}})},add:function(e){e&&arrAppend(t,e)}}}var strGetPlugin="getPlugin",defaultValues=((_a$1={})[STR_EXTENSION_CONFIG]={isVal:isNotNullOrUndefined,v:{}},_a$1),BaseTelemetryPlugin=function(){function e(){var o,a,c,s,l,i=this;function t(e){var t,e=e=void 0===e?null:e;return e||(t=a||createProcessTelemetryContext(null,{},i[STR_CORE]),e=c&&c[strGetPlugin]?t[_DYN_CREATE_NEW](null,c[strGetPlugin]):t[_DYN_CREATE_NEW](null,c)),e}function _(e,t,n){createDynamicConfig(e,defaultValues,safeGetLogger(t)),!n&&t&&(n=t[_DYN_GET_PROCESS_TEL_CONT2]()[_DYN_GET_NEXT]());var r=c;c&&c[strGetPlugin]&&(r=c[strGetPlugin]()),i[STR_CORE]=t,a=createProcessTelemetryContext(n,e,t,r)}function f(){o=!1,i[STR_CORE]=null,c=a=null,l=createUnloadHookContainer(),s=createUnloadHandlerContainer()}f(),dynamicProto(e,i,function(u){u[_DYN_INITIALIZE]=function(e,t,n,r){_(e,t,r),o=!0},u[_DYN_TEARDOWN]=function(e,t){var n,r,o,a,i=u[STR_CORE];if(i&&(!e||i===e[STR_CORE]()))return r=!1,o=e||createProcessTelemetryUnloadContext(null,i,c&&c[strGetPlugin]?c[strGetPlugin]():c),a=t||{reason:0,isAsync:!1},u[_DYN__DO_TEARDOWN]&&!0===u[_DYN__DO_TEARDOWN](o,a,_)?n=!0:_(),n;function _(){r||(r=!0,s.run(o,t),l.run(o[_DYN_DIAG_LOG]()),!0===n&&o[_DYN_PROCESS_NEXT](a),f())}},u[_DYN_UPDATE]=function(e,t){var n,r,o,a=u[STR_CORE];if(a&&(!e||a===e[STR_CORE]()))return r=!1,o=e||createProcessTelemetryUpdateContext(null,a,c&&c[strGetPlugin]?c[strGetPlugin]():c),u._doUpdate&&!0===u._doUpdate(o,t||{reason:0},i)?n=!0:i(),n;function i(){r||(r=!0,_(o.getCfg(),o.core(),o[_DYN_GET_NEXT]()))}},proxyFunctionAs(u,"_addUnloadCb",function(){return s},"add"),proxyFunctionAs(u,"_addHook",function(){return l},"add"),objDefine(u,"_unloadHooks",{g:function(){return l}})}),i[_DYN_DIAG_LOG]=function(e){return t(e)[_DYN_DIAG_LOG]()},i[_DYN_IS_INITIALIZED]=function(){return o},i.setInitialized=function(e){o=e},i[_DYN_SET_NEXT_PLUGIN]=function(e){c=e},i[_DYN_PROCESS_NEXT]=function(e,t){t?t[_DYN_PROCESS_NEXT](e):c&&isFunction(c[STR_PROCESS_TELEMETRY])&&c[STR_PROCESS_TELEMETRY](e,null)},i._getTelCtx=t}return e.__ieDyn=1,e}(),strOnPrefix="on",strAttachEvent="attachEvent",strAddEventHelper="addEventListener",strDetachEvent="detachEvent",strRemoveEventListener="removeEventListener",strEvents="events",rRemoveEmptyNs=(createUniqueNamespace("aiEvtPageHide"),createUniqueNamespace("aiEvtPageShow"),/\.[\.]+/g),rRemoveTrailingEmptyNs=/[\.]+$/,_guid=1,elmNodeData=createElmNodeData("events"),eventNamespace=/^([^.]*)(?:\.(.+)|)/;function _normalizeNamespace(e){return e&&e[_DYN_REPLACE]?e[_DYN_REPLACE](/^[\s\.]+|(?=[\s\.])[\.\s]+$/g,STR_EMPTY):e}function _getEvtNamespace(e,t){t&&(n=STR_EMPTY,isArray(t)?(n=STR_EMPTY,arrForEach(t,function(e){(e=_normalizeNamespace(e))&&("."!==e[0]&&(e="."+e),n+=e)})):n=_normalizeNamespace(t),n&&("."!==n[0]&&(n="."+n),e=(e||STR_EMPTY)+n));var n,t=eventNamespace.exec(e||STR_EMPTY)||[];return{type:t[1],ns:(t[2]||STR_EMPTY).replace(rRemoveEmptyNs,".").replace(rRemoveTrailingEmptyNs,STR_EMPTY)[_DYN_SPLIT](".").sort().join(".")}}function _getRegisteredEvents(e,t,n){e=elmNodeData.get(e,strEvents,{},n=void 0===n||n);return e[t]||(e[t]=[])}function _doDetach(e,t,n,r){e&&t&&t[_DYN_TYPE]&&(e[strRemoveEventListener]?e[strRemoveEventListener](t[_DYN_TYPE],n,r):e[strDetachEvent]&&e[strDetachEvent](strOnPrefix+t[_DYN_TYPE],n))}function _doAttach(e,t,n,r){var o=!1;return e&&t&&t[_DYN_TYPE]&&n&&(e[strAddEventHelper]?(e[strAddEventHelper](t[_DYN_TYPE],n,r),o=!0):e[strAttachEvent]&&(e[strAttachEvent](strOnPrefix+t[_DYN_TYPE],n),o=!0)),o}function _doUnregister(e,t,n,r){for(var o=t[_DYN_LENGTH];o--;){var a=t[o];!a||n.ns&&n.ns!==a[_DYN_EVT_NAME].ns||r&&!r(a)||(_doDetach(e,a[_DYN_EVT_NAME],a.handler,a.capture),t[_DYN_SPLICE](o,1))}}function _unregisterEvents(n,r,o){var e;r[_DYN_TYPE]?_doUnregister(n,_getRegisteredEvents(n,r[_DYN_TYPE]),r,o):(objForEachKey(e=elmNodeData.get(n,strEvents,{}),function(e,t){_doUnregister(n,t,r,o)}),0===objKeys(e)[_DYN_LENGTH]&&elmNodeData.kill(n,strEvents))}function mergeEvtNamespace(e,t){return t?_getEvtNamespace("xx",isArray(t)?[e].concat(t):[e,t]).ns[_DYN_SPLIT]("."):e}function eventOn(e,t,n,r,o){void 0===o&&(o=!1);var a=!1;if(e)try{var i,_=_getEvtNamespace(t,r);(a=_doAttach(e,_,n,o))&&elmNodeData.accept(e)&&(i={guid:_guid++,evtName:_,handler:n,capture:o},_getRegisteredEvents(e,_.type)[_DYN_PUSH](i))}catch(u){}return a}function eventOff(e,t,n,r,o){if(void 0===o&&(o=!1),e)try{var a=_getEvtNamespace(t,r),i=!1;_unregisterEvents(e,a,function(e){return!((!a.ns||n)&&e.handler!==n)&&(i=!0)}),i||_doDetach(e,a,n,o)}catch(_){}}var DisabledPropertyName="Microsoft_ApplicationInsights_BypassAjaxInstrumentation",_DYN_FEATURE_OPT_IN="featureOptIn",_DYN_SCHEDULE_FETCH_TIMEO0="scheduleFetchTimeout";function replaceByNonOverrideCfg(e,n,r,o){try{var t=o<r,a=(t&&(e=null),0==r?objExtend({},e):e);return a&&n&&!t&&objForEachKey(a,function(e){var t=n[e];t&&(isObject(a[e])&&isObject(t)?a[e]=replaceByNonOverrideCfg(a[e],t,++r,o):delete a[e])}),a}catch(i){}return e}var _a,F="featureOptIn.",M=".mode",ON=".onCfg",OFF=".offCfg";function resolveCdnFeatureCfg(e,t,n){if(!t||!t.enabled)return null;var t=(t[_DYN_FEATURE_OPT_IN]||{})[e]||{mode:1},r=t.mode,o=t.onCfg,t=t.offCfg,n=(n||{})[e]||{mode:2},a=n.mode,i=n.onCfg,_=n.offCfg,n=!!n.blockCdnCfg,u=F+e+ON,c=F+e+OFF,s=a,l=i,f=_;return n||(4===r||5===r?(s=4==r?3:2,l=o||i,f=t||_):2===r||2===a?(s=2,l=i||o,f=_||t):3===r?(s=3,l=i||o,f=_||t):1===r&&1===a&&(s=1)),(n={})[F+e+M]=s,n[u]=l,n[c]=f,n}function applyCdnfeatureCfg(n,r){try{if(!n||!n.enabled)return null;if(!n[_DYN_FEATURE_OPT_IN])return n.config;var e=n[_DYN_FEATURE_OPT_IN],o=n.config||{};return objForEachKey(e,function(e){var t=resolveCdnFeatureCfg(e,n,r.config[_DYN_FEATURE_OPT_IN]);isNullOrUndefined(t)||(objForEachKey(t,function(e,t){setValueByKey(o,e,t)}),_overrideCdnCfgByFeature(e,t,o))}),o}catch(t){}return null}function _overrideCdnCfgByFeature(e,t,n){var r=t[F+e+M],o=t[F+e+ON],e=t[F+e+OFF],t=2===r?e:3===r?o:null;t&&objForEachKey(t,function(e,t){setValueByKey(n,e,t)})}var EVENT_NAME="ai_cfgsync",STR_GET_METHOD="GET",FETCH_TIMEOUT=18e5,udfVal=undefined,defaultNonOverrideCfg={instrumentationKey:!0,connectionString:!0,endpointUrl:!0},_defaultConfig=objDeepFreeze(((_a={syncMode:1,blkCdnCfg:udfVal,customEvtName:udfVal,cfgUrl:udfVal,overrideSyncFn:udfVal,overrideFetchFn:udfVal,onCfgChangeReceive:udfVal})[_DYN_SCHEDULE_FETCH_TIMEO0]=FETCH_TIMEOUT,_a.nonOverrideConfigs=defaultNonOverrideCfg,_a.enableAjax=!1,_a)),CfgSyncPlugin=function(n){function o(){var D,C,O,P,v,e,b,m,S,h,A,L,R,I,Y,F,U,t=n.call(this)||this,r=(t.priority=198,!(t.identifier="AppInsightsCfgSyncPlugin"));return dynamicProto(o,t,function(_,u){function n(){U=!1,L=F=Y=S=A=h=e=R=m=b=v=P=O=C=null}function c(e,t){if(e){if(C=e,t&&!r)return l();if(b&&!r)return _.core.updateCfg(e),!0}return!1}function s(){try{var e=getGlobal();e&&eventOff(e,null,null,P)}catch(t){}}function l(e){try{return F&&isFunction(F)?F(C,e):sendCustomEvent(O,C,e)}catch(t){}return!1}function f(e){try{if(s(),e&&(O=e,b)){var t=getGlobal();if(t)try{eventOn(t,O,function(e){var e=e&&e.detail;L&&e?L(e):(e=(e=e&&e.cfg)&&isPlainObject(e)&&p(e))&&c(e)},P,!0)}catch(n){}}return!0}catch(r){}return!1}function y(e,n,r){var t=getGlobal(),t=t&&t.fetch||null;if(e&&t&&isFunction(t))try{var o={method:STR_GET_METHOD},a=(U||(o[DisabledPropertyName]=!0),new Request(e,o));if(!U)try{a[DisabledPropertyName]=!0}catch(i){}doAwaitResponse(fetch(a),function(e){var t=e.value;e.rejected?g(n,400):t.ok?doAwaitResponse(t.text(),function(e){g(n,t.status,e.value,r)}):g(n,t.status,null,r)})}catch(i){}}function E(e,t,n){try{var r=new XMLHttpRequest;U||(r[DisabledPropertyName]=!0),r.open(STR_GET_METHOD,e),r.onreadystatechange=function(){r.readyState===XMLHttpRequest.DONE&&g(t,r.status,r.responseText,n)},r.onerror=function(){g(t,400)},r.ontimeout=function(){g(t,400)},r.send()}catch(o){}}function N(e,t,n){try{var r,o,a;200<=e&&e<400&&t?(A=0,(r=getJSON())&&(a=(o=applyCdnfeatureCfg(r.parse(t),_.core))&&isPlainObject(o)&&p(o))&&c(a,n)):A++,A<3&&d()}catch(i){}}function g(e,t,n,r){try{e(t,n,r)}catch(o){}}function p(e){var t=null;try{e&&(t=replaceByNonOverrideCfg(e,R,0,5))}catch(n){}return t}function d(){!e&&h&&(e=scheduleTimeout(function(){e=null,I(v,N,m)},h)).unref()}function T(){e&&e.cancel(),e=null,A=0}n(),_.initialize=function(e,t,n,r){var o,a,i;u.initialize(e,t,n,r),P=mergeEvtNamespace(createUniqueNamespace(_.identifier),t.evtNamespace&&t.evtNamespace()),a=_.identifier,i=_.core,_._addHook(onConfigChange(o=e,function(){var e=createProcessTelemetryContext(null,o,i),e=(D=e.getExtCfg(a,_defaultConfig),S),e=(S=!!D.blkCdnCfg,U=!!D.enableAjax,isNullOrUndefined(e)||e===S||(!S&&v?I&&I(v,N,m):T()),isNullOrUndefined(b)&&(b=2===D.syncMode),isNullOrUndefined(m)&&(m=1===D.syncMode),D.customEvtName||EVENT_NAME);O!==e&&(b?f(e):(s(),O=e)),(v=isNullOrUndefined(v)?D.cfgUrl:v)||(C=o,m&&l())})),F=D.overrideSyncFn,Y=D.overrideFetchFn,L=D.onCfgChangeReceive,R=D.nonOverrideConfigs,h=D[_DYN_SCHEDULE_FETCH_TIMEO0],isNullOrUndefined(n=Y)&&(isFetchSupported()?n=y:isXhrSupported()&&(n=E)),I=n,A=0,v&&!S&&I&&I(v,N,m)},_.getCfg=function(){return C},_.pause=function(){r=!0,T()},_.resume=function(){r=!1,d()},_.setCfg=function(e){return c(e)},_.sync=l,_.updateEventListenerName=f,_._doTeardown=function(e,t){s(),T(),n()},_._getDbgPlgTargets=function(){return[m,b,O,S,R]},_.processTelemetry=function(e,t){_.processNext(e,t)}}),t}return __extendsFn(o,n),o.__ieDyn=1,o}(BaseTelemetryPlugin);exports.CfgSyncPlugin=CfgSyncPlugin;
//# sourceMappingURL=ai.cfgsync.3.cjs.min.js.map
